unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Grids, StdCtrls,
  LCLType, ComCtrls, Types;

type

  { TForm1 }

  TForm1 = class(TForm)
    GridEditor: TEdit;
    GridWithEditor: TStringGrid;
    pc: TPageControl;
    GridNoEditor: TStringGrid;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    procedure FormShow(Sender: TObject);
    procedure GridNoEditorColRowInserted(Sender: TObject; IsColumn: Boolean;
      sIndex, tIndex: Integer);
    procedure GridNoEditorDrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
    procedure GridNoEditorKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GridNoEditorSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: string);
    procedure GridNoEditorValidateEntry(sender: TObject; aCol, aRow: Integer;
      const OldValue: string; var NewValue: String);
    procedure GridWithEditorKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GridWithEditorSelectEditor(Sender: TObject; aCol, aRow: Integer;
      var Editor: TWinControl);
  private
    Function AttrExistsInGrid(sg: TStringGrid; s: String): Boolean;
  public

    State: Integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormShow(Sender: TObject);
begin
  pc.ActivePage := TabSheet2;
  GridWithEditor.SetFocus;
end;


// -----------------------------------------------------------------------------
// Doublettenprüfung für beide Grids
// -----------------------------------------------------------------------------
Function TForm1.AttrExistsInGrid(sg: TStringGrid; s: String): Boolean;
var i : Integer;
begin
  Result := false;
  if sg.RowCount > 2 then
  begin
    for i := 1 to sg.RowCount-1 do
    begin
      if i <> sg.Row then
      begin
        if sg.Cells[4,i] = s then result := True;
      end;
    end;
  end;
end;

// -----------------------------------------------------------------------------
// Anfang Grid mit SelectEditor

procedure TForm1.GridWithEditorSelectEditor(Sender: TObject; aCol,
  aRow: Integer; var Editor: TWinControl);
begin
  if (aRow > 0) and (aCol = 4) then
  begin
    GridEditor.BoundsRect := GridWithEditor.CellRect(aCol,aRow);
    GridEditor.Text := GridWithEditor.Cells[aCol,aRow];
    Editor := GridEditor;
  end;
end;

procedure TForm1.GridWithEditorKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_DOWN) and (GridWithEditor.Row = GridWithEditor.RowCount-1) then
  begin
    GridWithEditor.RowCount:=GridWithEditor.RowCount+1;
    GridWithEditor.EditorMode:=True;
  end;
end;

// Ende Grid mit SelectEditor
// -----------------------------------------------------------------------------



// -----------------------------------------------------------------------------
// Anfang Grid ohne SelectEditor
// -----------------------------------------------------------------------------

procedure TForm1.GridNoEditorKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_DOWN) and (State = 0) then
  begin
    if (Key = VK_DOWN) and (GridNoEditor.Row = GridNoEditor.RowCount-1) then GridNoEditor.RowCount := GridNoEditor.RowCount + 1;
  end;
  if (State = 1) then
  begin
    GridNoEditor.Row := GridNoEditor.RowCount-1;
    GridNoEditor.Col := 4;
  end;
end;

procedure TForm1.GridNoEditorSetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: string);
begin
  if AttrExistsInGrid(GridNoEditor,GridNoEditor.Cells[GridNoEditor.Col,GridNoEditor.Row]) then State := 1;
end;

procedure TForm1.GridNoEditorColRowInserted(Sender: TObject; IsColumn: Boolean;
  sIndex, tIndex: Integer);
begin
  GridNoEditor.Col := 4;
  if AttrExistsInGrid(GridNoEditor,GridNoEditor.Cells[4,GridNoEditor.Row]) then State := 1;
  GridNoEditor.Refresh;
end;

procedure TForm1.GridNoEditorDrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
var
  sg : TStringGrid;
  c : TCanvas;
begin
  if aRow > 0 then
  begin
    sg := TStringGrid( Sender );
    c := sg.Canvas;

    c.Brush.Color := clWhite;
    c.Font.Color  := clDefault;
    c.Font.Style  := [];

    If (ACol>0) And (ARow>0) Then Begin
      If (aCol = GridNoEditor.Col) and (aRow = GridNoEditor.Row) then
      begin
        c.Brush.Color := clBlue;
        c.Font.Color:=clWhite;
      end;
    end;

    If (State = 1) and (aCol = 4) and (aRow = GridNoEditor.RowCount-1) then
    begin
      c.Brush.Color := clRed;
      c.Font.Color  :=clWhite;
    end;

    c.FillRect(aRect);
    c.TextOut(aRect.Left+2, aRect.Top+2, sg.Cells[ACol, ARow]);
  end;
end;

procedure TForm1.GridNoEditorValidateEntry(sender: TObject; aCol, aRow: Integer;
  const OldValue: string; var NewValue: String);
begin
  if State = 1 then
  begin
    GridNoEditor.RowCount:=GridNoEditor.RowCount-1;
    State := 0;
  end;
end;

// Ende Grid ohne SelectEditor
// -----------------------------------------------------------------------------



end.

